<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Stack and Queue</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

        <div class="reveal">
            <div class="slides">
                <!-- Introduction Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h1>Stack</h1>    
                    </section>
                    <section>
						<h2>Stack</h2>
						<p>A stack is a linear data structure in which elements can be inserted and deleted only from one side of the list, called the top.
						 </p>
					</section>
					<section>
						<p>A stack follows the LIFO (Last In First Out) principle, i.e., the element inserted at the last is the first element to come out.

					</p>
					</section>
                    <section>
						<h2>STACK</h2>
						<p>The insertion of an element into stack is called push operation, and deletion of an element from the stack is called pop operation. In stack we always keep track of the last element present in the list with a pointer called top.

						</p>
					</section>
					<section>
						<H3>STACK</H3>
							<ul>
								<li>Elements are sorted by insertion order.</li>
								<li>Elements can only add to top and remove to top</li>
								<li>Can be implemented using: Arrays or Linked lists</li>
							</ul>

					</section>
					<section>
						<img src="../../../assets/stack1.png" alt="stack1">
					</section>
					<section>
						<h3>Basic Operations</h3>
						<ul>
							<li>pop() - delete</li>
							<li>push() - insert/add</li>
							<li>isFull() - check if stack is full</li>
							<li>isEmpty() - check if stack is empty</li>
							<li>peek() - get the top data element of the stack, without removing it</li>
						</ul>
					</section>
					<section>
						<h3>Push Operation</h3>
						<p>Push operation involves a series of steps</p>
						<ul>
							<li>Step 1 - Checks if the stack is full</li>
							<li>Step 2 - If the stack is full, produces an error and exit</li>
							<li>Step 3 - If the stack is not full, increments top to point next empty space</li>
							<li>Step 4 - Adds data element to the stack location, where top is pointing</li>
							<li>Step 5 - returns success</li>

						</ul>
						<p>If the linked list is used to implement the stack, then in step 3, we need
							to allocate space dynamically
						</p>
					</section>
					<section>
						<h3>Algorithm for PUSH Operation</h3>
						<p>A simple algorithm for push operation can be derived as follows</p>
						<pre>
							<code data-trim data-noescape>
								begin procedure push: stack, data

								if stack is full
								   return null
								endif
								
								top ← top + 1
								stack[top] ← data
							 
							 end procedure
							</code>
						</pre>
					</section>
					<section>
						<h3>Implementation of this algorithm in C: </h3>
						<pre>
							<code data-trim data-noescape>
								void push(int data) {
									if(!isFull()) {
									   top = top + 1;   
									   stack[top] = data;
									} else {
									   printf("Could not insert data, Stack is full.\n");
									}
								 }
							</code>
						</pre>
					</section>
                </section>
                <!-- Statements and Blocks Section -->
                <section>   
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Pop Operation</h2>
						<p>Accessing the content while removing it from the stack, is known as a Pop Operation. 
							In an array implementation of pop() operation, the data element is not actually removed, instead top is decremented to a 
							lower position in the stack to point to the next value. But in linked-list implementation, 
							pop() actually removes data element and deallocates memory space</p>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<h3>Pop operation</h3>
						<p>A pop operation may involve the following steps:</p>
						<ul>
							<li>Step 1 - checks if the stack is empty</li>
							<li>step 2 - If the stack is empty, produces an error and exit</li>
							<li>Step 3 - If the stack is not empty, accesses the data element at which top is pointing</li>
							<li>Step 4 - Decreases the value of top by 1</li>
							<li>Step 5 - Returns success</li>
						</ul>
					</section>
					<section>
						<img src="../../../assets/stack2.png" alt="stack2">
					</section>
					<section>
						<h3>Pop Operation Algorithm</h3>
						<pre>
							<code data-trim data-noescape>
								begin procedure pop: stack

								if stack is empty
								   return null
								endif
								
								data ← stack[top]
								top ← top - 1
								return data
							 
							 end procedure
							</code>
						</pre>
					</section>
					<section>
						<p>Implementation of this algorithm in C:</p>
						<pre>
							<code data-trim data-noescape>
								int pop(int data) {

									if(!isempty()) {
									   data = stack[top];
									   top = top - 1;   
									   return data;
									} else {
									   printf("Could not retrieve data, Stack is empty.\n");
									}
								 }
							</code>
						</pre>
					</section>
                </section>
                <!-- If Statements Section -->
                <section>
                    <section>
						<h2>peek()</h2>
						<p>peek() − get the top data element of the stack, without removing it.</p>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Algorithm of peek() function </h2>
						<pre>
							<code data-trim data-noescape>
								begin procedure peek
									return stack[top]
								end procedure
							</code>
						</pre>
					</section>
					<section>
						<p>Implementation of peek() function in C:</p>
						<pre>
							<code data-trim data-noescape>
								int peek() {
									return stack[top];
								 }
							</code>
						</pre>
					</section>
                </section>
                <!-- if/else Statments Section -->
                <section>
                    <section>
						<h2>isfull()</h2>
						<p>isFull() − check if stack is full

						</p>
						<p>Algorithm example</p>
						<pre>
							<code data-trim data-noescape>
								begin procedure isfull

									if top equals to MAXSIZE
										return true
									else
										return false
									endif
									
									end procedure
							</code>
						</pre>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Implementation of isfull() function</h2>
						<pre>
							<code data-trim data-noescape>
								bool isfull() {
									if(top == MAXSIZE)
									   return true;
									else
									   return false;
								 }
							</code>
						</pre>
                    </section>
                </section>
                <!-- else/if Statements Section -->
                <section>
                    <section>
						<h2>isEmpty()</h2>
						<p>check if the stack is empty</p>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>isEmpty()</h2>
						<p>Algorithm example</p>
						<pre>
							<code data-trim data-noescape>
								begin procedure isempty

									if top less than 1
										return true
									else
										return false
									endif
									
									end procedure
							</code>
						</pre>
					</section>
					<section>
						<p>Implementation of isempty() function in C:</p>
						<pre>
							<code data-trim data-noescape>
								bool isempty() {
									if(top == -1)
									   return true;
									else
									   return false;
								 }
							</code>
						</pre>

					</section>
                </section>
                <!-- switch Statements Section -->
                <section>
                    <section>
                        <h2>Queue</h2>
							<p>Queue is an abstract data structure, somewhat similar to Stacks. 
								Unlike stacks, a queue is open at both its ends. One end is always used to 
								insert data (enqueue) and the other is used to remove data (dequeue). 
								Queue follows First-In-First-Out methodology, 
								i.e., the data item stored first will be accessed first.</p>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Queue</h2>
						<img src="../../../assets/queue1.png" alt="queue1">
					</section>
					<section>
						<h3>Basic Operations</h3>
						<p>Queue operations may involve initializing or defining the queue, 
							utilizing it, and then completely erasing it from the memory.</p>
					</section>
					<section>
						<p>The fundamental operations:</p>
						<ul>
							<li>enqueue() − add (store) an item to the queue.</li>
							<li>dequeue() − remove (access) an item from the queue.</li>
							<li>peek() − Gets the element at the front of the queue without removing it.</li>
							<li>isfull() - checks if the queue is full.</li>
							<li>isempty() - checks if the queue is empty</li>
						</ul>
					</section>
					<section>
						<h3>peek()</h3>
						<p>This function helps to see the data at the front of the queue</p>
						<p>Algorithm:</p>
						<pre>
							<code data-trim data-noescape>
								begin procedure peek
									return queue[front]
							 	end procedure
							</code>
						</pre>
					</section>
					<section>
						<p>Implementation of peek() in C:</p>
						<pre>
							<code data-trim data-noescape>
								int peek() {
									return queue[front];
								 }
							</code>
						</pre>
					</section>
                </section>
                <!-- Loops Section -->
                <section>
                    <section>
						<h2>isfull()</h2>
						<pre>
							<code data-trim data-noescape>
								begin procedure isfull

									if rear equals to MAXSIZE
										return true
									else
										return false
									endif
									
								end procedure
							</code>
						</pre>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
					</section>
					<section>
						<p>Implementation of the isfull() function:</p>
						<pre>
							<code data-trim data-noescape>
								bool isfull() {
									if(rear == MAXSIZE - 1)
									   return true;
									else
									   return false;
								 }
							</code>
						</pre>
					</section>
                    
                </section>
                <!-- while Loops Section -->
                <section>
                    <section>
						<h2>isempty()</h2>
						<p>Algorithm: </p>
						<pre>
							<code data-trim data-noescape>
								begin procedure isempty

									if front is less than MIN  OR front is greater than rear
										return true
									else
										return false
									endif
									
								end procedure
							</code>
						</pre>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Implementation of isempty() in C: </h2>
						<pre>
							<code data-trim data-noescape>
								bool isempty() {
									if(front < 0 || front > rear) 
									   return true;
									else
									   return false;
								 }
							</code>
						</pre>
                    </section>
                </section>
                <!-- do while Loops Section -->
                <section>
                    <section>
                        <h2>Enqueue Operation</h2>
						<p>Queues maintain two data pointers, front and rear. Therefore, 
							its operations are comparatively difficult to implement than that of stacks</p>
                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Enqueue function tasks </h2>
						<ul>
							<li>Step 1 − Check if the queue is full.</li>
							<li>Step 2 − If the queue is full, produce overflow error and exit.</li>
							<li>Step 3 − If the queue is not full, increment rear pointer to point the next empty space.</li>
							<li>Step 4 − Add data element to the queue location, where the rear is pointing.</li>
							<li>Step 5 - return success</li>
						</ul>
					</section>
					<section>
						<h3>Enqueue</h3>
						<img src="../../../assets/queue2.png" alt="queue2">
					</section>
					<section>
						<h3>Enqueue algorithm</h3>
						<pre>
							<code data-trim data-noescape>
									procedure enqueue(data)      
   
										if queue is full
											return overflow
										endif
										
										rear ← rear + 1
										queue[rear] ← data
										return true
										
									end procedure
							</code>
						</pre>
					</section>
					<section>
						<h3>Enqueue Implemenation</h3>
						<pre>
							<code data-trim data-noescape>
								int enqueue(int data)      
								if(isfull())
								   return 0;
								
								rear = rear + 1;
								queue[rear] = data;
								
								return 1;
						
							</code>
						</pre>
					</section>
                </section>
                <!-- Break Section -->
                <section>
                    <section>
                        <h2>Dequeue function</h2>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
						<h2>Dequeue operations </h2>
						<ul>
							<li>Step 1 − Check if the queue is empty.</li>
							<li>Step 2 − If the queue is empty, produce underflow error and exit.</li>
							<li>Step 3 − If the queue is not empty, access the data where front is pointing.</li>
							<li>Step 4 − Increment front pointer to point to the next available data element.</li>
							<li>Step 5 − Return success.</li>
						</ul>
					</section>
					<section>
						<img src="../../../assets/queue3.jpg" alt="queue3">
					</section>
					<section>
						<h3>Algorithm for Dequeue process</h3>
						<pre>
							<code data-trim data-noescape>
								procedure dequeue
   
									if queue is empty
										return underflow
									end if

									data = queue[front]
									front ← front + 1
									return true

								end procedure
						
							</code>
						</pre>
					</section>
					<section>
						<h3>Implemenation of the Dequeue process</h3>
						<pre>
							<code data-trim data-noescape>
								int dequeue() {
									if(isempty())
									   return 0;
								 
									int data = queue[front];
									front = front + 1;
								 
									return data;
								 }
						
							</code>
						</pre>
					</section>

                </section>
                <!-- Nested Control Flow Section -->
                <section>
                    <section>
						<h2>Applications of Queue Data Structure</h2>
						<ul>
							<li>CPU scheduling, Disk Scheduling</li>
							<li>When data is transferred asynchronously between two processes.The queue is used for synchronization.
								 eg: IO Buffers, pipes, file IO, etc</li>
							<li>Handling of interrupts in real-time systems</li>
							<li>Call Center phone systems use Queues to hold people calling them in an order</li>
						</ul>

                        <aside class="notes">
                            Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for instructor view!!
                        </aside>
                    </section>
                    <section>
                        <h2>Virtical slide </h2>
                    </section>
                </section>
 
                <!-- Conclusion Section -->
                <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                    <section>
                        <h2>Questions?</h2>
                    </section>
                    <section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
                        <h2>Summary</h2>
                        <ul>
                            <li>List</li>
                        </ul>
                    </section>
                </section>
            </div>
        </div>

        <footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

        // If slides do not have a matching title, attempt to use the
        // start of the text content as the title instead
        useTextContentForMissingTitles: false,

        // Hide slides from the menu that do not have a title.
        // Set to 'true' to only list slides with titles.
        hideMissingTitles: false,

        // Adds markers to the slide titles to indicate the 
        // progress through the presentation. Set to 'false'
        // to hide the markers.
        markers: true,

        // Specify custom panels to be included in the menu, by
        // providing an array of objects with 'title', 'icon'
        // properties, and either a 'src' or 'content' property.
        custom: false,

        // Specifies the themes that will be available in the themes
        // menu panel. Set to 'true' to show the themes menu panel
        // with the default themes list. Alternatively, provide an
        // array to specify the themes to make available in the
        // themes menu panel, for example...
        // [
        //     { name: 'Black', theme: 'css/theme/black.css' },
        //     { name: 'White', theme: 'css/theme/white.css' },
        //     { name: 'League', theme: 'css/theme/league.css' }
        // ]
        themes: true,

        // Specifies the path to the default theme files. If your
        // presentation uses a different path to the standard reveal
        // layout then you need to provide this option, but only
        // when 'themes' is set to 'true'. If you provide your own 
        // list of themes or 'themes' is set to 'false' the 
        // 'themesPath' option is ignored.
        themesPath: 'css/theme/',

        // Specifies if the transitions menu panel will be shown.
        // Set to 'true' to show the transitions menu panel with
        // the default transitions list. Alternatively, provide an
        // array to specify the transitions to make available in
        // the transitions panel, for example...
        // ['None', 'Fade', 'Slide']
        transitions: true,

        // Adds a menu button to the slides to open the menu panel.
        // Set to 'false' to hide the button.
        openButton: true,

        // If 'true' allows the slide number in the presentation to
        // open the menu panel. The reveal.js slideNumber option must 
        // be displayed for this to take effect
        openSlideNumber: true,

        // If true allows the user to open and navigate the menu using
        // the keyboard. Standard keyboard interaction with reveal
        // will be disabled while the menu is open.
        keyboard: true,

        // Normally the menu will close on user actions such as
        // selecting a menu item, or clicking the presentation area.
        // If 'true', the sticky option will leave the menu open
        // until it is explicitly closed, that is, using the close
        // button or pressing the ESC or m key (when the keyboard 
        // interaction option is enabled).
        sticky: true,

        // If 'true' standard menu items will be automatically opened
        // when navigating using the keyboard. Note: this only takes 
        // effect when both the 'keyboard' and 'sticky' options are enabled.
        autoOpen: true,

        // If 'true' the menu will not be created until it is explicitly
        // requested by calling RevealMenu.init(). Note this will delay
        // the creation of all menu panels, including custom panels, and
        // the menu button.
        delayInit: false,

        // If 'true' the menu will be shown when the menu is initialised.
        openOnInit: false,

        // By default the menu will load it's own font-awesome library
        // icons. If your presentation needs to load a different
        // font-awesome library the 'loadIcons' option can be set to false
        // and the menu will not attempt to load the font-awesome library.
        loadIcons: true
    },
    dependencies: [
        { src: 'plugin/markdown/marked.js' },
        { src: 'plugin/markdown/markdown.js' },
        { src: 'plugin/highlight/highlight.js' },
        { src: 'plugin/notes/notes.js', async: true },
        { src: 'plugin/reveal.js-menu/menu.js' }
    ]
});
</script>
</body>
</html>
